Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 471906 (CVE-2013-3724) - <www-servers/monkeyd-1.2.2 : Denial of Service Vulnerability (CVE-2013-3724)
Summary: <www-servers/monkeyd-1.2.2 : Denial of Service Vulnerability (CVE-2013-3724)
Status: RESOLVED FIXED
Alias: CVE-2013-3724
Product: Gentoo Security
Classification: Unclassified
Component: Vulnerabilities (show other bugs)
Hardware: All Linux
: Normal minor (vote)
Assignee: Gentoo Security
URL: http://www.1337day.com/exploit/20830
Whiteboard: B3 [glsa]
Keywords:
Depends on:
Blocks: CVE-2013-3843
  Show dependency tree
 
Reported: 2013-05-31 13:50 UTC by Agostino Sarubbo
Modified: 2013-09-25 17:14 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Agostino Sarubbo gentoo-dev 2013-05-31 13:50:44 UTC
From ${URL} :

Title:
======
Monkey HTTPD 1.1.1 - Denial of Service Vulnerability
  
Date:
=====
2013-05-28
  
References:
===========
http://bugs.monkey-project.com/ticket/181
  
Introduction:
=============
Monkey is a lightweight and powerful web server for GNU/Linux.
  
It has been designed to be very scalable with low memory and CPU consumption, the perfect solution for embedded devices. Made for ARM, x86 and x64.
  
Abstract:
=========
The vulnerability is a denial of service which is caused by sending a null byte in an HTTP request to the web server.
  
Report-Timeline:
================
2013-05-23: Discovered vulnerability via fuzzing
2013-05-25: Vendor Notification
2013-05-26: Vendor Response/Feedback
2013-05-27: Vendor Fix/Patch
2013-05-28: PublicDisclosure
  
Status:
========
Published
  
Affected Products:
==================
Monkey HTTPD - version 1.1.1
  
Exploitation-Technique:
=======================
Remote
  
Details:
========
A bug discovered in Monkey's HTTP parser allows an attacker to cause a segmentation fault in one of the daemon's threads using a specially crafted 
request containing a null byte. An attacker can crash all the available threads by sending the specially crafted request multiple times, rendering 
the server useless for legitimate users.
  
Proof of Concept:
=================
The vulnerability can be exploited by remote attacker without any special privileges. The placement of the null byte within the request does not seem 
to have any effect on the result. The null byte may even be used instead of an HTTP method such as, GET. Below is an example of how this bug can be 
manually triggered:
  
ruby -e 'puts "GET /\x00 HTTP/1.1\r\n\r\n"'|netcat localhost 2001
  
Solution:
=========
This vulnerability has been fixed for the 1.2.0 release.
  
Risk:
=====
The security risk of the redirection vulnerability is estimated as low(+).


@maintainer(s): after the bump, in case we need to stabilize the package, please say explicitly if it is ready for the stabilization or not.
Comment 1 Anthony Basile gentoo-dev 2013-06-22 10:51:52 UTC
This is fixed in the recent versions I added to the tree, but there are still more security bugs open on monkeyd.
Comment 2 Anthony Basile gentoo-dev 2013-06-30 15:43:34 UTC
We should not wait any longer. 

    TARGET: "amd64 arm ppc ppc64 x86"

Note this also takes care of bugs #472400 and #472644.  It does not take care of a couple other security issues.
Comment 3 Agostino Sarubbo gentoo-dev 2013-06-30 18:16:54 UTC
amd64 stable
Comment 4 Agostino Sarubbo gentoo-dev 2013-06-30 18:17:23 UTC
x86 stable
Comment 5 Agostino Sarubbo gentoo-dev 2013-06-30 21:10:57 UTC
ppc stable
Comment 6 Agostino Sarubbo gentoo-dev 2013-07-04 14:13:23 UTC
ppc64 stable
Comment 7 Agostino Sarubbo gentoo-dev 2013-07-07 12:06:35 UTC
arm stable
Comment 8 Chris Reffett gentoo-dev Security 2013-07-12 01:46:18 UTC
Note that monkeyd needs a GLSA anyway, bug 472400 is a B2.
Comment 9 Sergey Popov gentoo-dev Security 2013-08-23 09:55:38 UTC
GLSA vote: yes
Comment 10 GLSAMaker/CVETool Bot gentoo-dev 2013-08-29 18:07:31 UTC
CVE-2013-3724 (http://nvd.nist.gov/nvd.cfm?cvename=CVE-2013-3724):
  The mk_request_header_process function in mk_request.c in Monkey 1.1.1
  allows remote attackers to cause a denial of service (thread crash and
  service outage) via a '\0' character in an HTTP request.
Comment 11 Tobias Heinlein (RETIRED) gentoo-dev 2013-09-03 16:46:24 UTC
Added to existing request.
Comment 12 GLSAMaker/CVETool Bot gentoo-dev 2013-09-25 17:14:14 UTC
This issue was resolved and addressed in
 GLSA 201309-17 at http://security.gentoo.org/glsa/glsa-201309-17.xml
by GLSA coordinator Chris Reffett (creffett).